package com.dermandar.panoramal;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.RelativeLayout;
import android.widget.TextView;


public class Lenses extends Activity {
    View currentSelectedLens = null;
    int selectedColor = Color.rgb(217,217,217);
    String selectedLensId;
    String selectedLensName;
    String prefLensKey = "LensSelected";
    String prefLensNameKey = "LensSelectedName";
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);

        setContentView(R.layout.activity_lenses);

        RelativeLayout lens = (RelativeLayout)findViewById(R.id.none);
        lens.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                selectLens(v);
            }
        });

        TextView txtCancel = (TextView)findViewById(R.id.cancel);
        txtCancel.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                finish();

            }
        });

        TextView txtDone = (TextView)findViewById(R.id.done);
        txtDone.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v){
                SharedPreferences pref = getApplicationContext().getSharedPreferences("MyPref", MODE_PRIVATE);
                SharedPreferences.Editor editor = pref.edit();
                editor.putString(prefLensKey, selectedLensId);
                editor.putString(prefLensNameKey, selectedLensName);
                editor.commit();
                Intent data = new Intent();
                data.putExtra("lensId",selectedLensId);
                data.putExtra("lensName",selectedLensName);
                setResult(RESULT_OK,data);
                finish();
            }
        });

        selectedLensId = getIntent().getStringExtra("CurrentLens");
        int resID = getResources().getIdentifier(selectedLensId, "id", getPackageName());
        View lensRow = this.findViewById(resID);
        selectLens(lensRow);
    }
    public void selectLens(View selectedLens)
    {
        if(currentSelectedLens != null)
            currentSelectedLens.setBackgroundColor(Color.TRANSPARENT);
        selectedLens.setBackgroundColor(selectedColor);

        currentSelectedLens = selectedLens;
        selectedLensId = getResources().getResourceEntryName(selectedLens.getId());
        selectedLensName = selectedLens.getTag().toString();
    }
}
