package com.dermandar.panoramal;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.GradientDrawable;
import android.location.LocationManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.provider.Settings;
import android.support.v4.app.ActivityCompat;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.Gravity;
import android.view.Surface;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.dermandar.dmd_lib.CallbackInterfaceShooter;
import com.dermandar.dmd_lib.DMD_Capture;
import com.nativesystem.Core;

import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Timer;

public class ShooterActivity extends Activity  {
    public static boolean IS_HD = false;
    private boolean drawcircle = true;

    private RelativeLayout mRelativeLayout = null;
    private DMD_Capture mDMDCapture;
    private boolean mIsShootingStarted = false;
    private boolean mIsCameraReady=false;

    private int mWidth = 400, mHeight = 500;

    private String mPanoramaPath;
    private String mEquiPath = "";
    private int mScreenWidth, mScreenHeight;
    private double mAspectRatio;
    ImageView circle;
    ViewGroup viewGroup;
    boolean saveOri = true;
    private int mDisplayRotation;
    final int request_Code = 103;
    String prefModeKey = "ShotMode";
    String prefLensKey = "LensSelected";
    String prefLensNameKey = "LensSelectedName";
    String selectedLens = "none";
    String lensName = "None";
    TextView txtLensName;
    Button txtShootMode;
    ImageView imgRotMode;
    boolean showYinYang = true;
    private boolean camAdded = false; //used in case when permissions are asked or bluetooth to turn on i requested (onresume is entered before on create sub)
    //Button startShooting;
    double FL;
    float activityW,activityH;
    boolean isRequestExit = false;
    boolean isRequestViewer = false;
    enum detectResult{
        DMDCircleDetectionInvalidInput,
        DMDCircleDetectionCircleNotFound,
        DMDCircleDetectionBad,
        DMDCircleDetectionGood
    }
    private final detectResult[] circleResult = detectResult.values();
    enum fisheye{
        none,
    }

    ViewGroup camPreview;
    boolean isSDKRotator = false;
    boolean isHDREnabled = false;
    ShooterActivity self=this;
    int lensIDRotator=0;
    boolean isRotatorShooterReady = false;

    private DisplayMetrics mDisplayMetrics;
    private int mCurrentInstructionMessageID = -1;
    private TextView mTextViewInstruction;
    private int mNumberTakenImages = 0;

    //Permissions
    public static final int MY_PERMISSIONS_REQUEST_LOCATION = 1;
    public static final int MY_PERMISSIONS_REQUEST_CAMERA = 2;
    public static final int MY_PERMISSIONS_REQUEST_STORAGE = 3;
    int REQUEST_ENABLE_BT = 104;
    public static boolean locationAsked = false;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Log.e("rmh","oncreate");

        requestWindowFeature(Window.FEATURE_NO_TITLE);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);


        //onCreateSub();
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            if ((ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED) &&
                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) == PackageManager.PERMISSION_GRANTED) &&
                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) &&
                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED) &&
                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE) == PackageManager.PERMISSION_GRANTED))
            {
                validateBluetooth();
                return;
            }
            else if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED)
            {
                requestPermissions(new String[]{android.Manifest.permission.CAMERA}, MY_PERMISSIONS_REQUEST_CAMERA);
                return;
            }
            else if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ||
                    ActivityCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED)
            {
                requestPermissions(new String[]{android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, MY_PERMISSIONS_REQUEST_STORAGE);
                return;
            }
            else if((ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) ||
                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED))
            {
                ActivityCompat.requestPermissions(this, new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION, android.Manifest.permission.ACCESS_COARSE_LOCATION}, MY_PERMISSIONS_REQUEST_LOCATION);
                return;
            }
        }

        validateBluetooth();
    }
    @Override
    public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults) {
        Log.e("rmh","onRequestPermissionsResult main");
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            switch (requestCode) {
                case MY_PERMISSIONS_REQUEST_CAMERA: {
                    Log.e("rmh", "MY_PERMISSIONS_REQUEST_CAMERA");
                    // If request is cancelled, the result arrays are empty.
                    if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ||
                                ActivityCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED)
                        {
                            ActivityCompat.requestPermissions(this, new String[]{android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE}, MY_PERMISSIONS_REQUEST_STORAGE);
                            return;
                        }
                        else if((ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) ||
                                (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED))
                        {
                            ActivityCompat.requestPermissions(this, new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION, android.Manifest.permission.ACCESS_COARSE_LOCATION}, MY_PERMISSIONS_REQUEST_LOCATION);
                            return;
                        }
                        else
                            validateBluetooth();
                    } else {
                        toastMessage("Camera, Storage and Location permissions are not optional!");
                        finish();
                    }
                    return;
                }
                case MY_PERMISSIONS_REQUEST_STORAGE: {
                    Log.e("rmh", "MY_PERMISSIONS_REQUEST_STORAGE");
                    if (grantResults.length > 1 && grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED) {
                        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA) == PackageManager.PERMISSION_GRANTED) {
                            if((ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED) ||
                                    (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED))
                            {
                                ActivityCompat.requestPermissions(this, new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION, android.Manifest.permission.ACCESS_COARSE_LOCATION}, MY_PERMISSIONS_REQUEST_LOCATION);
                                return;
                            }
                            validateBluetooth();
                        } else {
                            toastMessage("Camera, Storage and Location permissions are not optional!");
                            finish();
                            return;
                        }
                    } else {
                        toastMessage("Camera, Storage and Location permissions are not optional!");
                        finish();
                        return;
                    }
                }
                case MY_PERMISSIONS_REQUEST_LOCATION: {
                    Log.e("rmh", "MY_PERMISSIONS_REQUEST_LOCATION");
                    if (grantResults.length > 1 && grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED) {
                        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA) != PackageManager.PERMISSION_GRANTED) {
                            toastMessage("Camera, Storage and Location permissions are not optional!");
                            finish();
                            return;
                        }
                        else if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED ||
                                ActivityCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE) != PackageManager.PERMISSION_GRANTED) {
                            toastMessage("Camera, Storage and Location permissions are not optional!");
                            finish();
                            return;
                        }
                        validateBluetooth();
                    }
                    else
                    {
                        toastMessage("Camera, Storage and Location permissions are not optional!");
                        finish();
                        return;
                    }
                }
            }
        }
    }

    private void validateBluetooth()
    {
        //onCreateSub();
        BluetoothAdapter mBluetoothAdapter;
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        if (mBluetoothAdapter == null) {
            // Device does not support Bluetooth
            toastMessage("Your phone does not support Bluetooth");
            return;
        }
        if(!mBluetoothAdapter.isEnabled())
        {
            Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
        }
        else
        {
            onCreateSub();
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode == REQUEST_ENABLE_BT)
        {
            if(resultCode == RESULT_CANCELED)
            {
                toastMessage("Bluetooth is not optional.\nTurn on bluetooth and restart the app.");
                return;
            }
            else
            {
                onCreateSub();
            }
        }
        else if (requestCode == request_Code) {
            if (resultCode == RESULT_OK) {
                circle.setVisibility(View.INVISIBLE);

                String lensId = data.getStringExtra("lensId");
                lensName = data.getStringExtra("lensName");
                if(lensId != null) {
                    selectedLens = lensId;
                    if (selectedLens.equals("none"))
                        mDMDCapture.setLensSelected(false);
                    else
                        mDMDCapture.setLensSelected(true);
                    setNewLens(getLensNb(selectedLens));
                }
                Log.e("rmh","aaaa:" + selectedLens);
            }
        }
    }

    private void onCreateSub()
    {
        Log.e("rmh","oncreatesub");
        //validate location on
        if(!locationAsked)
        {
            LocationManager lm = (LocationManager)this.getSystemService(this.LOCATION_SERVICE);
            boolean gps_enabled = false;
            boolean network_enabled = false;

            try {
                gps_enabled = lm.isProviderEnabled(LocationManager.GPS_PROVIDER);
            } catch(Exception ex) {}

            try {
                network_enabled = lm.isProviderEnabled(LocationManager.NETWORK_PROVIDER);
            } catch(Exception ex) {}

            if(!gps_enabled && !network_enabled) {
                // notify user
                AlertDialog.Builder dialog = new AlertDialog.Builder(this);
                dialog.setMessage("Your GPS is turned off, you may need to turn it on to connect to the Bluetooth rotator");
                dialog.setPositiveButton("Open Location Setting", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface paramDialogInterface, int paramInt) {
                        // TODO Auto-generated method stub
                        Intent myIntent = new Intent( Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                        startActivity(myIntent);
                        //get gps
                    }
                });
                dialog.setNegativeButton("Ignore", new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface paramDialogInterface, int paramInt) {
                        // TODO Auto-generated method stub

                    }
                });
                //dialog.set
                dialog.show();
                locationAsked = true;
            }
        }


        //end validate location on

        SharedPreferences pref = getApplicationContext().getSharedPreferences("MyPref", MODE_PRIVATE);
        String lastShootMode = pref.getString(prefModeKey,"");
        if(lastShootMode.equals(""))
        {
            SharedPreferences.Editor editor = pref.edit();
            if(isSDKRotator)
                editor.putString(prefModeKey, "rotator");
            else
                editor.putString(prefModeKey, "hand");
            editor.commit();
        }
        else {
            if(lastShootMode.equals("rotator"))
                isSDKRotator = true;
            else
                isSDKRotator = false;
        }
        mDisplayMetrics = new DisplayMetrics();
        mDisplayRotation = getWindowManager().getDefaultDisplay().getRotation();

        String path = Environment.getExternalStorageDirectory() + "/" + folderName;
        File _path = new File(path);
        _path.mkdirs();

        Log.e("rmh","path:**" + path);
        //Core.setLogPath(path);
        //Core.setDebugPathRotator(path);

        //getting screen resolution
        Display mDisplay = getWindowManager().getDefaultDisplay();
        DisplayMetrics mDisplayMetrics = new DisplayMetrics();
        mDisplay.getMetrics(mDisplayMetrics);
        int mDisplayRotation = getWindowManager().getDefaultDisplay().getRotation();

        //Full screen activity
        //requestWindowFeature(Window.FEATURE_NO_TITLE);


        if (mDisplayRotation == Surface.ROTATION_0 || mDisplayRotation == Surface.ROTATION_180) {
            mScreenWidth = mDisplayMetrics.widthPixels;
            mScreenHeight = mDisplayMetrics.heightPixels;
        } else {
            mScreenWidth = mDisplayMetrics.heightPixels;
            mScreenHeight = mDisplayMetrics.widthPixels;
        }
        mAspectRatio = (double) mScreenHeight / (double) mScreenWidth;

        if (mAspectRatio < 1.0) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        }

        setContentView(R.layout.activity_shooter);

        mRelativeLayout = (RelativeLayout)findViewById(R.id.relativeLayout);

        Display display = getWindowManager().getDefaultDisplay();
        DisplayMetrics displayMetrics = new DisplayMetrics();
        display.getMetrics(displayMetrics);

        mWidth = displayMetrics.widthPixels;
        mHeight = displayMetrics.heightPixels;

        startShooter();

        RelativeLayout.LayoutParams lp;
        RelativeLayout.LayoutParams lp0 = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);

        //Text View instruction
        mTextViewInstruction = new TextView(this);
        mTextViewInstruction.setTextSize(32f);
        mTextViewInstruction.setGravity(Gravity.CENTER);
        mTextViewInstruction.setTextColor(Color.WHITE);
        setInstructionMessage(R.string.tap_anywhere_to_start);
        mRelativeLayout.addView(mTextViewInstruction,lp0);

        //circle
        DisplayMetrics displaymetrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(displaymetrics);
        circle = new ImageView((Context)this);
        circle.setAlpha(0.3f);
        if(drawcircle)
            mRelativeLayout.addView(circle);

        GradientDrawable shape =  new GradientDrawable();
        shape.setCornerRadius(50);
        shape.setColor(Color.parseColor("#88a8a8a8"));
        txtLensName = new TextView(this);
        txtLensName.setTextSize(16f);
        txtLensName.setGravity(Gravity.CENTER);
        txtLensName.setTextColor(Color.BLACK);
        txtLensName.setPadding(20,20,20,20);
        txtLensName.setBackground(shape);
        lp = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT); // You might want to tweak these to WRAP_CONTENT
        lp.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
        lp.addRule(RelativeLayout.ALIGN_PARENT_RIGHT);
        lp.bottomMargin = 200;
        lp.rightMargin = 20;
        mRelativeLayout.addView(txtLensName,lp);


        String lastUsedLense = pref.getString(prefLensKey,"none");
        if(lastUsedLense.equals(""))
        {
            SharedPreferences.Editor editor = pref.edit();
            editor.putString(prefLensKey, selectedLens);
            editor.commit();
        }
        else {
            selectedLens = lastUsedLense;
            lensName = pref.getString(prefLensNameKey,"No Lens");
        }

        imgRotMode = new ImageView(this);
        if(isSDKRotator)
            imgRotMode.setImageResource(R.drawable.rotator_disconn);
        else
            imgRotMode.setImageResource(R.drawable.handheld);
        //imgRotMode.setBackgroundColor(Color.WHITE);

        lp = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT); // You might want to tweak these to WRAP_CONTENT
        lp.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
        lp.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
        lp.bottomMargin = 200;
        lp.leftMargin = 70;
        mRelativeLayout.addView(imgRotMode,lp);

        imgRotMode.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //if(mIsShootingStarted) return;
                if(mDMDCapture != null)
                {
                    isSDKRotator = !isSDKRotator;

                    SharedPreferences pref = getApplicationContext().getSharedPreferences("MyPref", MODE_PRIVATE);
                    SharedPreferences.Editor editor = pref.edit();
                    if(isSDKRotator)
                        editor.putString(prefModeKey, "rotator");
                    else
                        editor.putString(prefModeKey, "hand");
                    editor.commit();

                    if(isSDKRotator) {
                        imgRotMode.setImageResource(R.drawable.rotator_disconn);
                        mDMDCapture.prepareFlipMode(isSDKRotator);
                    }
                    else {
                        imgRotMode.setImageResource(R.drawable.handheld);
                        mDMDCapture.prepareFlipMode(isSDKRotator);
                    }

                    // start solve fast switch issue
                    final ProgressDialog progress = new ProgressDialog(ShooterActivity.this);
                    progress.setTitle((isSDKRotator?"C":"Disc")+"onnecting...");
                    progress.setMessage((isSDKRotator?"Connecting to":"Disconnecting from") + " rotator");
                    progress.setCancelable(false); // disable dismiss by tapping outside of the dialog
                    progress.show();
                    imgRotMode.setEnabled(false);

                    Handler h = new Handler();
                    h.postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            progress.dismiss();
                            imgRotMode.setEnabled(true);
                        }
                    }, 2000);
                    // end solve fast switch issue
                }
            }
        });

        lp = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        lp.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
        lp.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
        lp.bottomMargin = 200;
        lp.leftMargin = 250;
        //if(!isRotatorMode)
        //txtRotConn.setVisibility(View.INVISIBLE);
        //mRelativeLayout.addView(txtRotConn,lp);

        txtLensName.setOnClickListener(new View.OnClickListener()
        {
            @Override
            public void onClick(View v) {

                if (!mIsShootingStarted) {
                    //if(mDMDCapture.canShootHDR())
                    //  mDMDCapture.setHDRStatus(false);
                    Intent a = new Intent(ShooterActivity.this, Lenses.class);
                    a.putExtra("CurrentLens", selectedLens);
                    startActivityForResult(a, request_Code);
                }
            }
        });

        //setStartShootingHand();

        if (selectedLens.equals("none"))
            mDMDCapture.setLensSelected(false);
        else
            mDMDCapture.setLensSelected(true);
        FL = mDMDCapture.getFL();
        setNewLens(getLensNb(selectedLens));
    }

    private void startShooter()
    {
        Log.e("rmh","startShooter");
        isRequestViewer = false;
        mDMDCapture = new DMD_Capture();
        mDMDCapture.setRotatorMode(isSDKRotator);
        if(saveOri)
            mDMDCapture.setExportOriOn();
        mDMDCapture.setCircleDetectionCallback(new DMD_Capture.CircleDetectionCallback()
        {
            @Override
            public void onCircleDetectionFinished(int res) {
                detectResult x = detectResult.values()[res];
                Log.e("rmh","result detection:" + res);

                if(!drawcircle)
                {
                    if(x == detectResult.DMDCircleDetectionInvalidInput)
                    {
                        Toast.makeText(ShooterActivity.this, "Something went wrong in detecting the lens.", Toast.LENGTH_SHORT).show();
                    }
                    return;
                }
                if(x == detectResult.DMDCircleDetectionInvalidInput)
                {
                    Toast.makeText(ShooterActivity.this, "Something went wrong in detecting the lens.", Toast.LENGTH_SHORT).show();
                }
                else if(x == detectResult.DMDCircleDetectionCircleNotFound)
                {
                    drawCircle(R.drawable.yellowcircle);
                }
                else if(x == detectResult.DMDCircleDetectionBad)
                {
                    drawCircle(R.drawable.redcircle);
                }
                else if(x == detectResult.DMDCircleDetectionGood)
                {
                    drawCircle(R.drawable.greencircle);
                }
            }
        });

        if(mDMDCapture.canShootHD()) {
            mDMDCapture.setResolutionHD();
            IS_HD = true;
        }

        viewGroup = mDMDCapture.initShooter((ShooterActivity)this, mCallbackInterface, getWindowManager().getDefaultDisplay().getRotation(), true, true);
        mRelativeLayout.addView(viewGroup,0);
        viewGroup.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!mIsCameraReady)return;
                if(!mIsShootingStarted) {
                    mNumberTakenImages = 0;
                    mPanoramaPath = Environment.getExternalStorageDirectory() + "/Lib_Test/";
                    mIsShootingStarted = mDMDCapture.startShooting(mPanoramaPath);
                    if(mIsShootingStarted)
                    {
                        imgRotMode.setVisibility(View.INVISIBLE);
                        txtLensName.setVisibility(View.INVISIBLE);
                    }
                    else
                    {
                        imgRotMode.setVisibility(View.VISIBLE);
                        txtLensName.setVisibility(View.VISIBLE);
                    }
//                    mIsShootingStarted = true;
                }
                else {
                    //Log.e("rmh")
                    mDMDCapture.finishShooting();
                    mIsShootingStarted = false;
                    imgRotMode.setVisibility(View.VISIBLE);
                    txtLensName.setVisibility(View.VISIBLE);
                }
            }
        });
    }

    private void toastMessage(String message) {
        Toast.makeText(this, message, Toast.LENGTH_SHORT).show();
    }

    public int getLensNb(String selectedLens)
    {
        int i = fisheye.valueOf(selectedLens).ordinal();
        return i;
    }

    public void setNewLens(int lensId)
    {
        txtLensName.setText(lensName);
        lensIDRotator=lensId;
        mDMDCapture.setLens(lensId);
    }
    @Override
    protected void onPause() {
        Log.e("rmh","onpause");
        super.onPause();
        getWindow().clearFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        if(mDMDCapture != null) {
            if (mIsShootingStarted) {
                mDMDCapture.stopShooting();
                mIsShootingStarted = false;
            }
            mDMDCapture.stopCamera();
        }
    }

    @Override
    protected void onResume() {
        Log.e("rmh","on resume");
        super.onResume();
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        if(mDMDCapture != null) {
            Log.e("AMS", "onResume::startCamera");
            mDMDCapture.startCamera((Context) this, mWidth, mHeight);
            //mDMDCapture.setContinuousShooting(true);
        }
        if(mTextViewInstruction != null)
            mTextViewInstruction.setVisibility(View.VISIBLE);
        if(imgRotMode != null)
            imgRotMode.setVisibility(View.VISIBLE);
        if(txtLensName != null)
            txtLensName.setVisibility(View.VISIBLE);
    }

    @Override
    public void onBackPressed() {
        Log.e("rmh","onbackpressed");

        if (mIsShootingStarted) {
            mDMDCapture.stopShooting();
            mIsShootingStarted = false;
            imgRotMode.setVisibility(View.VISIBLE);
            txtLensName.setVisibility(View.VISIBLE);
        } else {
            isRequestExit = true;
            isRequestViewer = false;
            mDMDCapture.releaseShooter();
            //super.onBackPressed();
        }
    }

    void myToast(String msg)
    {
        Context context = getApplicationContext();
        int duration = Toast.LENGTH_LONG;
        Toast toast = Toast.makeText(context, msg, duration);
        toast.show();
    }

    private void getRelativeLayoutInfo(){
        RelativeLayout relMain = (RelativeLayout) findViewById(R.id.relativeLayout);
        activityW = relMain.getWidth();
        activityH = relMain.getHeight();
    }

    void drawCircle(int _resId)
    {
        View relMain = (RelativeLayout) findViewById(R.id.relativeLayout);
        DisplayMetrics dm = new DisplayMetrics();
        this.getWindowManager().getDefaultDisplay().getMetrics(dm);
        int topOffset = dm.heightPixels - relMain.getMeasuredHeight();
        View tempView = viewGroup;
        int[] position = new int[2];
        tempView.getLocationOnScreen(position);
        final int y = position[1] - topOffset;
        final int resId = _resId;
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                int dim[] = new int[2];

                viewGroup.getLocationInWindow(dim);
                Log.e("rmh","dim:" + dim[0] + " " + dim[1]);
                int dim2[] = new int[2];
                viewGroup.getLocationOnScreen(dim2);
                activityW = viewGroup.getWidth();
                activityH = viewGroup.getHeight();
                int marginLeft, marginRight, marginTop, marginBottom;
                float circlediameter;
                float[] circleValues ;

                circleValues = Core.getCircleData(activityW, activityH, 0, dim[0], FL);

                marginTop = Math.round(circleValues[0] + dim[1]) ;
                marginRight = Math.round(circleValues[1]);
                marginBottom = Math.round(circleValues[2]);
                marginLeft = Math.round(circleValues[3]);
                circlediameter = (circleValues[4]);
                Log.e("rmh","mars: " + marginLeft + " " + marginRight + " " + marginTop + " " + marginBottom);
                //circle
                circle.setImageResource(resId);

                RelativeLayout.LayoutParams lp = new RelativeLayout.LayoutParams(RelativeLayout.LayoutParams.WRAP_CONTENT, RelativeLayout.LayoutParams.WRAP_CONTENT);
                lp.leftMargin = - marginLeft; //-margin; -marginLeft;
                lp.rightMargin = - marginRight; //-margin; -marginRight;
                lp.topMargin =  marginTop;
                lp.bottomMargin = -marginBottom;
                lp.width = Math.round(circlediameter);
                lp.height = Math.round(circlediameter);
                circle.setLayoutParams(lp);
                circle.setVisibility(View.VISIBLE);
            }
        });
    }

    String folderName = "Panoramas";
    public void saveDataSph()
    {
        String path = Environment.getExternalStorageDirectory() + "/" + folderName;
        File fileLinks = new File(path + "/data.txt");
        try {
            String s = new String("count\t1\nfovx\t360\ntype\tsph\n".getBytes(), "UTF-8");
            byte x[] = s.getBytes();
            FileOutputStream fos = new FileOutputStream(fileLinks, false);
            fos.write(x);
            fos.close();
        } catch (Exception e) {
        }
    }
    public void saveDataCyl(String fovx)
    {
        String path = Environment.getExternalStorageDirectory() + "/" + folderName;
        File fileLinks = new File(path + "/data.txt");
        try {
            String data = "count\t1\nfovx\t" + fovx + "\ntype\tcyl\n";
            String s = new String(data.getBytes(), "UTF-8");
            byte x[] = s.getBytes();
            FileOutputStream fos = new FileOutputStream(fileLinks, false);
            fos.write(x);
            fos.close();
        } catch (Exception e) {
        }
    }
    String imgName;
    private boolean mIsOpenGallery=false;
    private CallbackInterfaceShooter mCallbackInterface = new CallbackInterfaceShooter() {

        @Override
        public void onCameraStopped()
        {
            mIsShootingStarted = false;
            mIsCameraReady=false;
            if(tmr!=null)tmr.cancel(); tmr=null;
        }

        @Override
        public void onCameraStarted()
        {
            mIsCameraReady=true;
//            if(tmr!=null) tmr.cancel(); tmr=null;
//            tmr=new Timer();
//            tmr.scheduleAtFixedRate(new TimerTask() {
//                @Override
//                public void run() {
//					cnt++;
//					if(lastMillis==0)lastMillis=System.nanoTime();
//					if(System.nanoTime()-lastMillis>=1*1000000000) {
//						Log.e("DMD", "fps: " + cnt);
//						cnt=0;
//						lastMillis=System.nanoTime();
//					}
//
//                    HashMap<String, Object> map = mDMDCapture.getIndicators();
//					Log.e("DMD", "fovx:" + map.get(DMD_Capture.ShootingIndicatorsEnum.fovx.toString()));//Integer value in degrees
//					Log.e("DMD", "orientation:" + map.get(DMD_Capture.ShootingIndicatorsEnum.orientation.toString()));//Integer, kPanoramaOrientationLTR = -1, kPanoramaOrientationUnknown = 0, kPanoramaOrientationRTL = 1
            // Log.e("DMD", "percentage:" + map.get(DMD_Capture.ShootingIndicatorsEnum.percentage.toString()));//Double
//					Log.e("DMD", "pitch:" + map.get(DMD_Capture.ShootingIndicatorsEnum.pitch.toString()));//Double
//					Log.e("DMD", "roll:" + map.get(DMD_Capture.ShootingIndicatorsEnum.roll.toString()));//Double
//                }
//            },0, 16);
        }

        @Override
        public void onFinishClear()
        {

        }

        @Override
        public void onFinishRelease()
        {
            mRelativeLayout.removeView(viewGroup);
            viewGroup = null;
            if(isRequestExit)
            {
                finish();
                return;
            }
            mDMDCapture.startCamera(ShooterActivity.this, mWidth, mHeight);
        }

        private long cnt=0;
        private long lastMillis=0;
        @Override
        public void onDirectionUpdated(float a)
        {

//			cnt++;
//			if(lastMillis==0)lastMillis=System.nanoTime();
//			if(System.nanoTime()-lastMillis>1*1000000000) {
//				//Log.e("AMS", "fps: " + cnt);
//				cnt=0;
//				lastMillis=System.nanoTime();
//			}
//			Thread t=new Thread(new Runnable() {
//				@Override
//				public void run() {
//					try {
//						Thread.sleep((long)100);
//					} catch (InterruptedException e) {
//						e.printStackTrace();
//					}
//
//					HashMap<String, Object> map = mDMDCapture.getIndicators();
////					Log.e("AMS", "fovx:" + map.get(DMD_Capture.ShootingIndicatorsEnum.fovx.toString()));//Integer value in degrees
//					//Log.e("AMS", "orientation:" + map.get(DMD_Capture.ShootingIndicatorsEnum.orientation.toString()));//Integer, kPanoramaOrientationLTR = -1, kPanoramaOrientationUnknown = 0, kPanoramaOrientationRTL = 1
//					//Log.e("AMS", "percentage:" + map.get(DMD_Capture.ShootingIndicatorsEnum.percentage.toString()));//Double
////					Log.e("AMS", "pitch:" + map.get(DMD_Capture.ShootingIndicatorsEnum.pitch.toString()));//Double
////					Log.e("AMS", "roll:" + map.get(DMD_Capture.ShootingIndicatorsEnum.roll.toString()));//Double
////					Log.e("AMS", "roll:" + map.get(DMD_Capture.ShootingIndicatorsEnum.roll.toString()));
//				}
//			});
//			t.start();
        }

        private Timer tmr;
        @Override
        public void preparingToShoot() {
            /***
             * Example about reading the shooting indicators
             */
        }

        @Override
        public void canceledPreparingToShoot() {

        }

        @Override
        public void takingPhoto() {
        }

        @Override
        public void shotTakenPreviewReady(Bitmap bitmapPreview) {

        }

        @Override
        public void photoTaken() {
            Log.e("rmh", "photoTaken");
            HashMap<String, Object> map = mDMDCapture.getIndicators();
            mNumberTakenImages++;
            if (mNumberTakenImages <= 0) {
                setInstructionMessage(R.string.tap_anywhere_to_start);
            } else if (mNumberTakenImages == 1) {
                setInstructionMessage(R.string.rotate_left_or_right_or_tap_to_restart);
            } else {
                setInstructionMessage(R.string.tap_to_finish_when_ready_or_continue_rotating);
            }

//					Log.e("AMS", "fovx:" + map.get(DMD_Capture.ShootingIndicatorsEnum.fovx.toString()));//Integer value in degrees
//            Log.e("AMS", "orientation:" + map.get(DMD_Capture.ShootingIndicatorsEnum.orientation.toString()));//Integer, kPanoramaOrientationLTR = -1, kPanoramaOrientationUnknown = 0, kPanoramaOrientationRTL = 1
//            Log.e("AMS", "percentage:" + map.get(DMD_Capture.ShootingIndicatorsEnum.percentage.toString()));//Double
        }

        @Override
        public void stitchingCompleted(HashMap<String, Object> info) {
            Log.e("rmh", "stitching completed");
            long time= System.currentTimeMillis();
            imgName = "img_" + Long.toString(time) + ".jpg";

            mEquiPath = Environment.getExternalStorageDirectory().getPath() + "/" + folderName + "/" + imgName;
            Log.e("AMS", "decode logo");
            BitmapFactory.Options op = new BitmapFactory.Options();
            op.inPreferredConfig = Bitmap.Config.ARGB_8888;
            Bitmap bmp = BitmapFactory.decodeResource(getResources(), R.drawable.logo, op);
            byte[] bytes=DMDBitmapToRGBA888.ImageToRGBA8888(bmp);
            float min_zenith=0;    //specifies the size of the top logo between 0..90 degrees, otherwise it is set to 0
            float min_nadir=0;     //specifies the size of the bottom logo between 0..90 degrees, otherwise it is set to 0
            int res = mDMDCapture.setLogo(bytes, min_zenith, min_nadir);
            //int res = mDMDCapture.setLogo(null,min_zenith,min_nadir);  // to use  default logo (DMD logo).
            Log.e("AMS", "logo set finished: " + res);
            mDMDCapture.genEquiAt(mEquiPath, 800, 0, 0,false,false);
            //mDMDCapture.releaseShooter();
        }

        @Override
        public void shootingCompleted(boolean finished) {
            Log.e("rmh","shootingCompleted: " + finished);
            if(finished) {
                //mTextViewInstruction.setVisibility(View.INVISIBLE);
                mDMDCapture.stopCamera();
            }
            mIsShootingStarted = false;
        }

        @Override
        public void deviceVerticalityChanged(int isVertical) {

            if (isVertical == 1) {
                if(!mIsShootingStarted)
                    setInstructionMessage(R.string.tap_anywhere_to_start);
            } else {
                setInstructionMessage(R.string.hold_the_device_vertically);
            }
        }

        @Override
        public void compassEvent(HashMap<String, Object> info) {
            Toast.makeText(ShooterActivity.this, "Compass interference", Toast.LENGTH_SHORT).show();
            mIsShootingStarted = false;
        }

        @Override
        public void onFinishGeneratingEqui() {
            Log.e("rmh", "onFinishGeneratingEqui");
            mIsShootingStarted = false;
            mDMDCapture.startCamera(getApplicationContext(), mWidth, mHeight);
            Toast.makeText(ShooterActivity.this, "Image saved to " + mEquiPath, Toast.LENGTH_LONG).show();

            //isRequestExit = true;
            //isRequestViewer = true;
            //mDMDCapture.stopCamera();
            //mDMDCapture.releaseShooter();

            imgRotMode.setVisibility(View.VISIBLE);
            txtLensName.setVisibility(View.VISIBLE);
        }

        @Override
        public void onExposureChanged(DMD_Capture.ExposureMode mode) {
            // TODO Auto-generated method stub
        }

        //rotaor
        @Override
        public void onRotatorConnected(){
            Log.e("rmh","rot connected");
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
//                    txtRotConn.setBackgroundColor(Color.GREEN);
                    imgRotMode.setImageResource(R.drawable.rotator_conn);
                }
            });
        }
        @Override
        public void onRotatorDisconnected(){
            Log.e("rmh","rot disconnected");
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
//                    txtRotConn.setBackgroundColor(Color.RED);

                    if(isSDKRotator)
                        imgRotMode.setImageResource(R.drawable.rotator_disconn);
                }
            });
        }
        @Override
        public void onStartedRotating(){}
        @Override
        public void onFinishedRotating(){}
    };

    private void setInstructionMessage(final int msgID) {
        if (mCurrentInstructionMessageID == msgID)
            return;
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
//                RelativeLayout.LayoutParams params = new RelativeLayout.LayoutParams(mDisplayMetrics.widthPixels, RelativeLayout.LayoutParams.WRAP_CONTENT);
//                params.addRule(RelativeLayout.CENTER_HORIZONTAL);
//
//                if (msgID == R.string.instruction_empty || msgID == R.string.hold_the_device_vertically || msgID == R.string.tap_anywhere_to_start
//                        || msgID == R.string.instruction_focusing) {
//                    params.addRule(RelativeLayout.CENTER_VERTICAL);
//                } else {
//                    params.addRule(RelativeLayout.ALIGN_PARENT_BOTTOM);
//                }
//
//                mTextViewInstruction.setLayoutParams(params);
                mTextViewInstruction.setText(msgID);
                mCurrentInstructionMessageID = msgID;
            }
        });
    }
}


